#include <QDebug>
#include <QTime>
#include "departtrains.h"

departTrains::departTrains(QObject *parent) :
    QObject(parent)
{
    accessManager = new QNetworkAccessManager(this);
}

void departTrains::demandeDeparts(QString idGare,int nbDep,QDateTime date)
{
    QNetworkRequest request;
    QString reqDate;
    if (date.isValid())
        reqDate = "&datedepart=" + date.toString("yyyy;M;d") + "&heuredep=" + date.toString("h;m");
    request.setUrl(QUrl("http://widget.canaltp.fr/Prochains_departs_15122009/dev/index.php?gare=" + QUrl::toPercentEncoding(idGare)+ QString("&nbredepart=%1").arg(nbDep) + reqDate));
    reply = accessManager->get(request);
    connect(reply,SIGNAL(finished()),this,SLOT(slotFinished()));
    connect(reply,SIGNAL(error(QNetworkReply::NetworkError)),this, SLOT(slotError(QNetworkReply::NetworkError)));
}

void departTrains::slotFinished()
{
    QByteArray data;
    QString var,val;
    QString nomGare,infosGenerales,infosCondDep;
    QList <ligneDepart> listeLignesDeparts;

    data = reply->readAll();
    //qDebug () << "departTrains::slotFinished: data:" << data ;
    QStringList listeResult = QString::fromUtf8(data).split('&',QString::SkipEmptyParts);
    while (!listeResult.isEmpty())
    {
        QString resLigne = listeResult.takeFirst();
        //qDebug () << "ligne: " << resLigne;
        QStringList listeLigne = resLigne.split('=');        

        if (listeLigne.size()==2)
        {            

            var = listeLigne.at(0).toLower();
            val = listeLigne.at(1);
            if (var=="nomgare")
                nomGare = val;
            else if (var=="infogene")
                infosGenerales = val;
            else if (var=="infoconditiondepart")
                infosCondDep = val;
            else if (var.startsWith("ligne"))
            {
                QStringList depart = val.split(';');
                QString typeTransport,gareArrivee,retard,causeRetard;
                QStringList garesDesservies;
                QTime heure;
                for (int i=0; i< depart.size(); i++)
                {
                    switch(i)
                    {
                    case 0:
                        typeTransport = depart.at(i);
                        break;
                    case 1: // à quoi sert ce champ ???
                        break;
                    case 2:
                        heure = QTime::fromString(depart.at(i),"hh:mm");
                        break;
                    case 3:
                        gareArrivee = depart.at(i);
                        break;
                    case 4:
                        garesDesservies = depart.at(i).split(',');
                        break;
                    case 5:
                        retard = depart.at(i);
                        break;
                    case 6:
                        causeRetard = depart.at(i);
                        // supprimer caractère bizarre
                        if (causeRetard.size() > 0)
                        {
                            QByteArray ba = causeRetard.toAscii();
                            char *data = ba.data();
                            char c = data[0];
                            if (c == -17)
                                causeRetard.remove(0,1);
                        }                                               
                        break;
                    }
                }
                ligneDepart ld = ligneDepart(typeTransport, heure, gareArrivee, garesDesservies, retard, causeRetard);
                listeLignesDeparts.append(ld);

                //qDebug () << "typeTransport: " << typeTransport << " heure: " << heure << " gareArrivee: " << gareArrivee << "garesDesservies: " << garesDesservies<<  "retard: "<< retard << "causeRetard: " << causeRetard;
            }

        }

    }
    emit(departsConnus(listeLignesDeparts));
}

void departTrains::slotError(QNetworkReply::NetworkError)
{
    //emit(erreurReseau(reply->errorString()));
}
