#include <QDebug>
#include "recherchegare.h"

rechercheGare::rechercheGare(QObject *parent) :
    QObject(parent)
{
    accessManager = new QNetworkAccessManager(this);
}

void rechercheGare::demandeServeur(QString recherche)
{
    QNetworkRequest request;

    request.setUrl(QUrl("http://widget.canaltp.fr/Prochains_departs_15122009/dev/gare.php?txtrech=" + QUrl::toPercentEncoding(recherche)));
    reply = accessManager->get(request);
    connect(reply,SIGNAL(finished()),this,SLOT(slotFinished()));
    connect(reply,SIGNAL(error(QNetworkReply::NetworkError)),this, SLOT(slotError(QNetworkReply::NetworkError)));
}

void rechercheGare::slotFinished()
{
    QByteArray data;
    QString gare,idGare;
    QList < QPair<QString,QString> > resultat;

    data = reply->readAll();
    QStringList listeResult = QString::fromUtf8(data).split('&',QString::SkipEmptyParts);

    while (!listeResult.isEmpty())
    {
        QString resGare = listeResult.takeFirst();
        QStringList listeGare = resGare.split('=');
        if (listeGare.size()==2)
        {
            idGare = listeGare.at(0);
            gare = listeGare.at(1);
            resultat.append(qMakePair(idGare,gare));
            //qDebug () << "Gare: " << gare << " idGare: " << idGare;
        }
    }
    emit (resConnu(resultat));

}

void rechercheGare::slotError(QNetworkReply::NetworkError)
{
    emit(erreurReseau(reply->errorString()));
}
